]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame - builder.sh
- add .cvsignore to PACKAGE/.cvsignore
[packages/rpm-build-tools.git] / builder.sh
CommitLineData
1d7abbe3 1#!/bin/ksh
44058243 2#
dece74ed
AM
3# This program is free software, distributed under the terms of
4# the GNU General Public License Version 2.
5#
cd445739 6# -----------
cd445739 7# Exit codes:
2a5f078d 8# 0 - succesful
9# 1 - help displayed
10# 2 - no spec file name in cmdl parameters
11# 3 - spec file not stored in repo
12# 4 - some source, patch or icon files not stored in repo
13# 5 - package build failed
14# 6 - spec file with errors
15# 7 - wrong source in /etc/poldek.conf
16# 8 - Failed installing buildrequirements and subrequirements
17# 9 - Requested tag already exist
18# 10 - Refused to build fractional release
19# 100 - Unknown error (should not happen)
cd445739 20
f8e50be5
ER
21# Notes (todo/bugs):
22# - builder -u fetches current version first (well that's okay, how you compare versions if you have no old spec?)
23# - when Icon: field is present, -5 and -a5 doesn't work
24# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
25# TODO:
26# - ability to do ./builder -bb foo.spec foo2.spec foo3.spec
931a4acf 27
d43959a2
ER
28RCSID='$Id$'
29r=${RCSID#* * }
30rev=${r%% *}
99b2e827 31VERSION="v0.23/$rev"
d43959a2 32VERSIONSTRING="\
c9acaed9 33Build package utility from PLD Linux CVS repository
f6711e2a 34$VERSION (C) 1999-2009 Free Penguins".
d43959a2 35
d6a77ddb 36PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
b03f053b 37
cd445739 38COMMAND="build"
64ea5308 39TARGET=""
cd445739 40
bde1c404 41SPECFILE=""
d287305c 42BE_VERBOSE=""
4003ad8c 43QUIET=""
cd445739
AM
44CLEAN=""
45DEBUG=""
46NOURLS=""
47NOCVS=""
48NOCVSSPEC=""
49NODIST=""
47761337 50NOINIT=""
bc10f694 51PREFMIRRORS=""
cd445739 52UPDATE=""
cd445739
AM
53ADD5=""
54NO5=""
55ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
c8f50498 56CVSROOT=""
cdbd30e8 57GREEDSRC=""
cd445739 58
6c1b2e7d
PZ
59# use rpm 4.4.6+ digest format instead of comments if non-zero
60USEDIGEST=
61
e3aa6f5e
ER
62# user agent when fetching files
63USER_AGENT="PLD/Builder($VERSION)"
64
cd445739
AM
65# It can be used i.e. in log file naming.
66# See LOGFILE example.
67DATE=`date +%Y-%m-%d_%H-%M-%S`
68
69# Example: LOGFILE='../log.$PACKAGE_NAME'
70# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
71# Yes, you can use variable name! Note _single_ quotes!
72LOGFILE=''
73
74LOGDIR=""
75LOGDIROK=""
76LOGDIRFAIL=""
77LASTLOG_FILE=""
78
79CHMOD="no"
1da227e8 80CHMOD_MODE="0644"
cd445739 81RPMOPTS=""
d1c5a9a7 82RPMBUILDOPTS=""
cd445739
AM
83BCOND=""
84GROUP_BCONDS="no"
ccffa567
ER
85
86# create symlinks for tools in PACKAGE_DIR, see get_spec()
daeab113 87SYMLINK_TOOLS="yes"
d287305c 88
89PATCHES=""
90SOURCES=""
cd445739 91ICONS=""
d287305c 92PACKAGE_RELEASE=""
93PACKAGE_VERSION=""
94PACKAGE_NAME=""
14bead22 95ASSUMED_NAME=""
cd445739
AM
96PROTOCOL="ftp"
97WGET_RETRIES=${MAX_WGET_RETRIES:-0}
cd445739 98
db5831da 99CVS_COMMAND=${CVS_COMMAND:-cvs}
939f2c12 100CVS_FORCE=""
f123bcb5 101CVSIGNORE_DF="yes"
939f2c12
ER
102CVS_RETRIES=${MAX_CVS_RETRIES:-1000}
103CVS_SERVER="cvs.pld-linux.org"
cd445739 104CVSTAG=""
939f2c12 105
cd445739
AM
106RES_FILE=""
107
cd445739 108DISTFILES_SERVER="://distfiles.pld-linux.org"
d4730dae 109ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
cd445739 110
36d03934 111DEF_NICE_LEVEL=19
86aafdbe 112SCHEDTOOL="auto"
cd445739
AM
113
114FAIL_IF_NO_SOURCES="yes"
115
18e5347d
ER
116# let get_files skip over files which are present to get those damn files fetched
117SKIP_EXISTING_FILES="no"
118
975d7b23 119TRY_UPGRADE=""
257af81b
ER
120# should the specfile be restored if upgrade failed?
121REVERT_BROKEN_UPGRADE="yes"
122
90baf90b
ER
123if rpm --specsrpm 2>/dev/null; then
124 FETCH_BUILD_REQUIRES_RPMSPECSRPM="yes"
ce40491a 125 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
90baf90b
ER
126else
127 FETCH_BUILD_REQUIRES_RPMSPECSRPM="no"
128 if [ -x /usr/bin/rpm-getdeps ]; then
129 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
130 else
131 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
132 fi
ab4a2b6e
ER
133fi
134
90baf90b 135
cd445739
AM
136# Here we load saved user environment used to
137# predefine options set above, or passed to builder
138# in command line.
139# This one reads global system environment settings:
140if [ -f ~/etc/builderrc ]; then
141 . ~/etc/builderrc
142fi
143# And this one cascades settings using user personal
144# builder settings.
145# Example of ~/.builderrc:
146#
147#UPDATE_POLDEK_INDEXES="yes"
148#FETCH_BUILD_REQUIRES="yes"
149#REMOVE_BUILD_REQUIRES="force"
150#GROUP_BCONDS="yes"
151#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
982e358c 152#TITLECHANGE=no
cd445739 153#
a83e5405 154SU_SUDO=""
cd445739
AM
155if [ -n "$HOME_ETC" ]; then
156 USER_CFG="$HOME_ETC/.builderrc"
20117088 157 BUILDER_MACROS="$HOME_ETC/.builder-rpmmacros"
cd445739
AM
158else
159 USER_CFG=~/.builderrc
20117088 160 BUILDER_MACROS=~/.builder-rpmmacros
cd445739
AM
161fi
162
163[ -f "$USER_CFG" ] && . "$USER_CFG"
164
86aafdbe
ER
165if [ "$SCHEDTOOL" = "auto" ]; then
166 if [ -x /usr/bin/schedtool ] && schedtool -B -e echo >/dev/null; then
167 SCHEDTOOL="schedtool -B -e"
168 else
169 SCHEDTOOL="no"
170 fi
171fi
172
ca2e6c31 173if [ -n "$USE_PROZILLA" ]; then
7e365483
KK
174 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
175 GETURI2="$GETURI"
176 OUTFILEOPT="-O"
ca2e6c31 177elif [ -n "$USE_AXEL" ]; then
cede92b3 178 GETURI="axel -a $AXEL_OPTS"
7e365483
KK
179 GETURI2="$GETURI"
180 OUTFILEOPT="-o"
ca2e6c31 181else
5700ee32
ER
182 wget --help 2>&1 | grep -q -- ' --no-check-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
183 wget --help 2>&1 | grep -q -- ' --inet ' && WGET_OPTS="$WGET_OPTS --inet"
184 wget --help 2>&1 | grep -q -- ' --retry-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
e3aa6f5e 185 WGET_OPTS="$WGET_OPTS --user-agent=$USER_AGENT"
6f9a5d76 186
7e365483
KK
187 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
188 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
189 OUTFILEOPT="-O"
2bc5451f 190fi
11468b23 191
11468b23
AM
192GETLOCAL="cp -a"
193
194if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
195 RPM="rpm"
196 RPMBUILD="rpm"
197else
198 RPM="rpm"
199 RPMBUILD="rpmbuild"
200fi
201
28c23a72
AG
202#
203# are we using cvs-nserver ?
204#
e21039da 205CVS_NSERVER=0
939f2c12 206$CVS_COMMAND --version 2>&1 | grep -q 'CVS-nserver'
e21039da 207[ $? -eq 0 ] && CVS_NSERVER=1
28c23a72 208
a8c9a155 209POLDEK_INDEX_DIR="$($RPM --eval %_rpmdir)/"
a83e5405 210POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
11468b23 211
f6711e2a 212run_poldek() {
525bf240 213 RES_FILE=$(mktemp -t builder.XXXXXX || ${TMPDIR:-/tmp}/builder.$RANDOM)
cd445739
AM
214 if [ -n "$LOGFILE" ]; then
215 LOG=`eval echo $LOGFILE`
216 if [ -n "$LASTLOG_FILE" ]; then
217 echo "LASTLOG=$LOG" > $LASTLOG_FILE
218 fi
86aafdbe 219 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
cd445739
AM
220 return $exit_pldk
221 else
86aafdbe 222 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
cd445739
AM
223 return `cat ${RES_FILE}`
224 rm -rf ${RES_FILE}
225 fi
226}
227
cd445739
AM
228#---------------------------------------------
229# functions
da946cd6 230
f6711e2a 231usage() {
cd445739
AM
232 if [ -n "$DEBUG" ]; then set -xv; fi
233 echo "\
d43959a2 234Usage: builder [-D|--debug] [-V|--version] [--short-version] [-a|--as_anon] [-b|-ba|--build]
6594293d 235[-bb|--build-binary] [-bs|--build-source] [-bc] [-bi] [-bl] [-u|--try-upgrade]
4efa0b98 236[{-cf|--cvs-force}] [{-B|--branch} <branch>] [{-d|--cvsroot} <cvsroot>]
19dc5591 237[-g|--get] [-h|--help] [--http] [{-l|--logtofile} <logfile>] [-m|--mr-proper]
238[-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T|--tag <cvstag>]
a7b2951c 239[-Tvs|--tag-version-stable] [-Ts|--tag-stable] [-Tv|--tag-version]
f8dba812 240[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}] [--use-greed-sources]
6594293d 241[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--short-circuit]
3009b80d 242[--show-bconds] [--with/--without <feature>] [--define <macro> <value>]
6594293d 243<package>[.spec][:cvstag]
2a5f078d 244
cd445739
AM
245-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
246-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
247-n5, --no-md5 - ignore md5 comments in spec
9243e80b
ER
248-D, --debug - enable builder script debugging mode,
249-debug - produce rpm debug package (same as --opts -debug)
d43959a2
ER
250-V, --version - output builder version string
251--short-version - output builder short version
cd445739
AM
252-a, --as_anon - get files via pserver as cvs@$CVS_SERVER,
253-b, -ba, --build - get all files from CVS repo or HTTP/FTP and build package
254 from <package>.spec,
255-bb, --build-binary - get all files from CVS repo or HTTP/FTP and build binary
256 only package from <package>.spec,
c56807e0 257-bp, --build-prep - execute the %prep phase of <package>.spec,
6594293d
AG
258-bc - execute the %build phase of <package>.spec,
259-bi - execute the %install phase of <package>.spec
260-bl - execute the %files phase of <package>.spec
cd445739
AM
261-bs, --build-source - get all files from CVS repo or HTTP/FTP and only pack
262 them into src.rpm,
6594293d 263--short-circuit - short-circuit build
cd445739
AM
264-B, --branch - add branch
265-c, --clean - clean all temporarily created files (in BUILD, SOURCES,
6f10b394
ER
266 SPECS and \$RPM_BUILD_ROOT and CVS/Entries) after rpmbuild commands.
267-m, --mr-proper - clean all temporarily created files (in BUILD, SOURCES,
268 SPECS and \$RPM_BUILD_ROOT and CVS/Entries). Doesn't run
269 any rpm building.
39dcc7de 270-cf, --cvs-force - use -F when tagging (useful when moving branches)
2a5f078d 271-d <cvsroot>, --cvsroot <cvsroot>
cd445739
AM
272 - setup \$CVSROOT,
273--define <macro> <value>
274 - define a macro <macro> with value <value>,
44058243
ER
275--alt_kernel <kernel>
276 - same as --define 'alt_kernel <kernel>'
cd445739
AM
277--nodeps - rpm won't check any dependences
278-g, --get - get <package>.spec and all related files from CVS repo
279 or HTTP/FTP,
280-h, --help - this message,
281--http - use http instead of ftp,
282-l <logfile>, --logtofile <logfile>
283 - log all to file,
cd445739
AM
284-nc, --no-cvs - don't download sources from CVS, if source URL is given,
285-ncs, --no-cvs-specs
286 - don't check specs in CVS
287-nd, --no-distfiles - don't download from distfiles
288-nm, --no-mirrors - don't download from mirror, if source URL is given,
289-nu, --no-urls - don't try to download from FTP/HTTP location,
290-ns, --no-srcs - don't download Sources
291-ns0, --no-source0 - don't download Source0
292-nn, --no-net - don't download anything from the net
a93e8cdf 293-pm, --prefer-mirrors - prefer mirrors (if any) over distfiles for SOURCES
b572253e 294--no-init - don't initialize builder paths (SPECS and SOURCES)
18e5347d
ER
295-ske,
296--skip-existing-files - skip existing files in get_files
cd445739
AM
297--opts <rpm opts> - additional options for rpm
298-q, --quiet - be quiet,
299--date yyyy-mm-dd - build package using resources from specified CVS date,
300-r <cvstag>, --cvstag <cvstag>
301 - build package using resources from specified CVS tag,
5323fffd 302-A - build package using CVS resources as any sticky tags/date/kopts being reset.
cd445739
AM
303-R, --fetch-build-requires
304 - fetch what is BuildRequired,
305-RB, --remove-build-requires
306 - remove all you fetched with -R or --fetch-build-requires
307 remember, this option requires confirmation,
308-FRB, --force-remove-build-requires
309 - remove all you fetched with -R or --fetch-build-requires
310 remember, this option works without confirmation,
06541433
JR
311-sd, --source-distfiles - list sources available from distfiles (intended for offline
312 operations; does not work when Icon field is present
313 but icon file is absent),
e15852ab 314-sc, --source-cvs - list sources available from CVS
06541433
JR
315-sdp, --source-distfiles-paths - list sources available from distfiles -
316 paths relative to distfiles directory (intended for offline
317 operations; does not work when Icon field is present
318 but icon file is absent),
a7eefc54 319-sf, --source-files - list sources - bare filenames (intended for offline
320 operations; does not work when Icon field is present
3621e588 321 but icon file is absent),
a7eefc54 322-sp, --source-paths - list sources - filenames with full local paths (intended for
323 offline operations; does not work when Icon field is present
3621e588 324 but icon file is absent),
2dddf439
ER
325-su, --source-urls - list urls - urls to sources and patches
326 intended for copying urls with spec with lots of macros in urls
cd445739
AM
327-T <cvstag> , --tag <cvstag>
328 - add cvs tag <cvstag> for files,
329-Tvs, --tag-version-stable
094bd95b 330 - add cvs tags STABLE and NAME-VERSION-RELEASE for files,
cd445739
AM
331-Ts, --tag-stable
332 - add cvs tag STABLE for files,
cd445739 333-Tv, --tag-version
1691a37b 334 - add cvs tag NAME-VERSION-RELEASE for files,
cd445739
AM
335-Tp, --tag-prefix <prefix>
336 - add <prefix> to NAME-VERSION-RELEASE tags,
337-tt, --test-tag <prefix>
338 - fail if tag is already present,
50321881
JK
339-ir, --integer-release-only
340 - allow only integer and snapshot releases
cd445739
AM
341-v, --verbose - be verbose,
342-u, --try-upgrade - check version, and try to upgrade package
343-un, --try-upgrade-with-float-version
344 - as above, but allow float version
f8dba812 345--use-greed-sources
346 - try download source from tag head if don't find it in
f5141bbc 347 current tag
deccc50e 348-U, --update - refetch sources, don't use distfiles, and update md5 comments
cd445739
AM
349-Upi, --update-poldek-indexes
350 - refresh or make poldek package index files.
c890b916 351-np, --nopatch <patchnumber>
bed98670 352 - don't apply <patchnumber>
dfe2cb9a
MK
353--show-bconds - show available conditional builds, which can be used
354 - with --with and/or --without switches.
9b78be50
ER
355--show-bcond-args - show active bconds, from ~/.bcondrc. this is used by
356 ./repackage.sh script. in other words, the output is
357 parseable by scripts.
cd445739
AM
358--with/--without <feature>
359 - conditional build package depending on %_with_<feature>/
360 %_without_<feature> macro switch. You may now use
361 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
362 constructions. Set GROUP_BCONDS to yes to make use of it.
6dd19291 363--target <platform>, --target=<platform>
3621e588
ER
364 - build for platform <platform>.
365--init-rpm-dir - initialize ~/rpm directory structure
5a491465 366"
367}
368
31d2bd0b
ER
369# change dependency to specname
370# common changes:
371# - perl(Package::Name) -> perl-Package-Name
372depspecname() {
373 local package="$1"
374
375 package=$(echo "$package" | sed -e '/perl(.*)/{s,perl(\(.*\)),perl-\1,;s,::,-,g}')
376 echo "$package"
377}
378
c890b916 379update_shell_title() {
a0d6396b 380 [ -t 1 ] || return
0b65d15e
ER
381 local len=${COLUMNS:-80}
382 local msg=$(echo "$*" | cut -c-$len)
383
e225de91
ER
384 if [ -n "$BE_VERBOSE" ]; then
385 echo >&2 "$(date +%s.%N) $*"
386 fi
387
982e358c 388 if [ "x$TITLECHANGE" == "xyes" -o "x$TITLECHANGE" == "x" ]; then
138bbc98
ER
389 local pkg
390 if [ -n "$PACKAGE_NAME" ]; then
391 pkg=${PACKAGE_NAME}-${PACKAGE_VERSION}-${PACKAGE_RELEASE}
392 else
393 pkg=${SPECFILE}
394 fi
395
396 msg="$pkg: ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
a8c9a155 397 msg=$(echo $msg | tr -d '\n\r')
982e358c
MP
398 case "$TERM" in
399 cygwin|xterm*)
400 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
401 ;;
402 screen*)
403 echo >&2 -ne "\033]0;$msg\007"
404 ;;
405 esac
406 fi
c890b916
ER
407}
408
7e40520f
ER
409# set TARGET from BuildArch: from SPECFILE
410set_spec_target() {
ce40491a 411 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
9c909460 412 tmp=$(awk '/^BuildArch:/ { print $NF}' $ASSUMED_NAME/$SPECFILE)
ce40491a 413 if [ "$tmp" ]; then
f9109a96 414 target_platform=$(rpm -E '%{_target_vendor}-%{_target_os}%{?_gnu}')
7e40520f
ER
415 TARGET="$tmp"
416 case "$RPMBUILD" in
417 "rpmbuild")
f9109a96 418 TARGET_SWITCH="--target ${TARGET}-${target_platform}" ;;
7e40520f 419 "rpm")
ce40491a 420 TARGET_SWITCH="--target=$TARGET" ;;
7e40520f 421 esac
ce40491a
ER
422 fi
423 fi
7e40520f
ER
424}
425
ace3fd80
ER
426# runs rpm with minimal macroset
427minirpm() {
fa4bf1df 428 # we reset macros not to contain macros.build as all the %() macros are
559d511f 429 # executed here, while none of them are actually needed.
559d511f 430 # at the time of this writing macros.build + macros contained 70 "%(...)" macros.
525bf240 431 safe_macrofiles=$(rpm $TARGET_SWITCH --showrc | awk -F: '/^macrofiles/ { gsub(/^macrofiles[ \t]+:/, "", $0); gsub(/:.*macros.build:/, ":", $0); print $0 } ')
ace3fd80
ER
432
433 # TODO: move these to /usr/lib/rpm/macros
20117088 434 cat > $BUILDER_MACROS <<'EOF'
5b5e5f7f 435%x8664 x86_64 amd64 ia32e
f78a0bb7 436%alt_kernel %{nil}
437%_alt_kernel %{nil}
fb198857
ER
438%requires_releq_kernel_up %{nil}
439%requires_releq_kernel_smp %{nil}
1b2bbc99 440%requires_releq_kernel %{nil}
6b8134e3 441%requires_releq() %{nil}
bb01dee9 442%pyrequires_eq() %{nil}
559d511f 443%requires_eq() %{nil}
c13be3d1 444%requires_eq_to() %{nil}
fb198857
ER
445%releq_kernel_up ERROR
446%releq_kernel_smp ERROR
1b2bbc99 447%releq_kernel ERROR
74d9fd14 448%kgcc_package ERROR
237bd3f1 449%_fontsdir ERROR
7141278d 450%ruby_version ERROR
451%ruby_ver_requires_eq() %{nil}
452%ruby_mod_ver_requires_eq() %{nil}
c13be3d1 453%__php_api_requires() %{nil}
7141278d 454%php_major_version ERROR
455%php_api_version ERROR
99f819cf
AM
456%requires_xorg_xserver_extension %{nil}
457%requires_xorg_xserver_xinput %{nil}
458%requires_xorg_xserver_font %{nil}
459%requires_xorg_xserver_videodrv %{nil}
7141278d 460%py_ver ERROR
41035426
ER
461%perl_vendorarch ERROR
462%perl_vendorlib ERROR
703ae20b
ER
463# damn. need it here! - copied from /usr/lib/rpm/macros.build
464%tmpdir %(echo "${TMPDIR:-/tmp}")
1f28fcb7
ER
465%patchset_source(f:b:) %(
466 base=%{-b*}%{!-b*:10000};
467 start=$(expr $base + %1);
468 end=$(expr $base + %{?2}%{!?2:%{1}});
469 # we need to call seq twice as it doesn't allow two formats
470 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
471 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
472 paste %{tmpdir}/__ps{1,2};
473 rm -f %{tmpdir}/__ps{1,2};
474) \
475%{nil}
991f09a5
ER
476%add_etc_shells(p) %{p:<lua>}
477%remove_etc_shells(p) %{p:<lua>}
709995c4
ER
478%lua_add_etc_shells() %{nil}
479%lua_remove_etc_shells() %{nil}
fb198857 480EOF
3d12d055 481 if [ "$NOINIT" = "yes" ] ; then
20117088 482 cat >> $BUILDER_MACROS <<'EOF'
3d12d055
JR
483%_specdir ./
484%_sourcedir ./
485EOF
c039643c 486 fi
fff1b991 487 eval $RPMBUILD $TARGET_SWITCH --macros "$safe_macrofiles:$BUILDER_MACROS" $QUIET $RPMOPTS $RPMBUILDOPTS $BCOND $* 2>&1
ace3fd80
ER
488}
489
490cache_rpm_dump() {
491 if [ -n "$DEBUG" ]; then
492 set -x
493 set -v
494 fi
495
d1d24c14 496 if [ -x /usr/bin/rpm-specdump ]; then
525bf240 497 update_shell_title "cache_rpm_dump using rpm-specdump command"
fff1b991 498 rpm_dump_cache=$(rpm-specdump $TARGET_SWITCH $BCOND $SPECFILE)
d1d24c14 499 else
525bf240 500 update_shell_title "cache_rpm_dump using rpmbuild command"
d1d24c14
ER
501 local rpm_dump
502 rpm_dump=`
503 # what we need from dump is NAME, VERSION, RELEASE and PATCHES/SOURCES.
504 dump='%{echo:dummy: PACKAGE_NAME %{name} }%dump'
505 case "$RPMBUILD" in
506 rpm)
507 ARGS='-bp'
508 ;;
509 rpmbuild)
510 ARGS='--nodigest --nosignature --nobuild'
511 ;;
512 esac
513 minirpm $ARGS --define "'prep $dump'" --nodeps $SPECFILE
514 `
515 if [ $? -gt 0 ]; then
516 error=$(echo "$rpm_dump" | sed -ne '/^error:/,$p')
517 echo "$error" >&2
518 Exit_error err_build_fail
519 fi
d05e8080 520
d1d24c14
ER
521 # make small dump cache
522 rpm_dump_cache=`echo "$rpm_dump" | awk '
523 $2 ~ /^SOURCEURL/ {print}
524 $2 ~ /^PATCHURL/ {print}
525 $2 ~ /^nosource/ {print}
526 $2 ~ /^PACKAGE_/ {print}
527 '`
528 fi
d05e8080 529
13974367 530 update_shell_title "cache_rpm_dump: OK!"
cd445739
AM
531}
532
ace3fd80 533rpm_dump() {
cd445739 534 if [ -z "$rpm_dump_cache" ] ; then
45e2a818 535 echo >&2 "internal error: cache_rpm_dump not called! (missing %prep?)"
cd445739
AM
536 fi
537 echo "$rpm_dump_cache"
538}
539
f6711e2a 540get_icons() {
d05e8080 541 update_shell_title "get icons"
9c909460 542 ICONS=$(awk '/^Icon:/ {print $2}' ${ASSUMED_NAME}/${SPECFILE})
d05e8080
ER
543 if [ -z "$ICONS" ]; then
544 return
545 fi
546
975d7b23 547 rpm_dump_cache="kalasaba" NODIST="yes" get_files $ICONS
d05e8080
ER
548}
549
f6711e2a 550parse_spec() {
af4d5315 551 update_shell_title "parsing specfile"
cd445739 552 if [ -n "$DEBUG" ]; then
518ff1fb
ER
553 set -x
554 set -v
cd445739 555 fi
b2975fc3 556
d05e8080 557 # icons are needed for successful spec parse
518ff1fb 558 get_icons
d05e8080 559
9c909460 560 cd $PACKAGE_DIR
cd445739 561 cache_rpm_dump
00fcec7e 562
cd445739 563 if [ "$NOSRCS" != "yes" ]; then
7823aac3 564 SOURCES=$(rpm_dump | awk '$2 ~ /^SOURCEURL[0-9]+/ {print substr($2, length("SOURCEURL") + 1), $3}' | LC_ALL=C sort -n | awk '{print $2}')
cd445739 565 fi
7cb24972 566
cd445739
AM
567 if (rpm_dump | grep -qEi ":.*nosource.*1"); then
568 FAIL_IF_NO_SOURCES="no"
569 fi
570
7823aac3 571 PATCHES=$(rpm_dump | awk '$2 ~ /^PATCHURL[0-9]+/ {print substr($2, length("PATCHURL") + 1), $3}' | LC_ALL=C sort -n | awk '{print $2}')
a8c9a155 572 ICONS=$(awk '/^Icon:/ {print $2}' ${SPECFILE})
dfe2b2d9
ER
573 PACKAGE_NAME=$(rpm_dump | awk '$2 == "PACKAGE_NAME" { print $3; exit}')
574 PACKAGE_VERSION=$(rpm_dump | awk '$2 == "PACKAGE_VERSION" { print $3; exit}')
575 PACKAGE_RELEASE=$(rpm_dump | awk '$2 == "PACKAGE_RELEASE" { print $3; exit}')
78eab2a1 576
0b4119a2 577 if [ "$PACKAGE_NAME" != "$ASSUMED_NAME" ]; then
7854d40c 578 echo >&2 "WARNING! Spec name ($ASSUMED_NAME) does not agree with package name ($PACKAGE_NAME)"
0b4119a2
JR
579 fi
580
cd445739
AM
581 if [ -n "$BE_VERBOSE" ]; then
582 echo "- Sources : `nourl $SOURCES`"
583 if [ -n "$PATCHES" ]; then
584 echo "- Patches : `nourl $PATCHES`"
585 else
586 echo "- Patches : *no patches needed*"
587 fi
588 if [ -n "$ICONS" ]; then
589 echo "- Icon : `nourl $ICONS`"
590 else
591 echo "- Icon : *no package icon*"
592 fi
593 echo "- Name : $PACKAGE_NAME"
594 echo "- Version : $PACKAGE_VERSION"
595 echo "- Release : $PACKAGE_RELEASE"
596 fi
13974367
ER
597
598 update_shell_title "parse_spec: OK!"
cd445739
AM
599}
600
f6711e2a 601Exit_error() {
cd445739 602 if [ -n "$DEBUG" ]; then
518ff1fb
ER
603 set -x
604 set -v
cd445739
AM
605 fi
606
607 cd "$__PWD"
608
609 case "$1" in
610 "err_no_spec_in_cmdl" )
611 remove_build_requires
45e2a818 612 echo >&2 "ERROR: spec file name not specified."
cd445739 613 exit 2 ;;
a08d92fc 614 "err_invalid_cmdline" )
45e2a818 615 echo >&2 "ERROR: invalid command line arg ($2)."
a08d92fc 616 exit 2 ;;
cd445739
AM
617 "err_no_spec_in_repo" )
618 remove_build_requires
45e2a818 619 echo >&2 "Error: spec file not stored in CVS repo."
cd445739
AM
620 exit 3 ;;
621 "err_no_source_in_repo" )
622 remove_build_requires
45e2a818 623 echo >&2 "Error: some source, patch or icon files not stored in CVS repo. ($2)"
cd445739
AM
624 exit 4 ;;
625 "err_build_fail" )
626 remove_build_requires
45e2a818 627 echo >&2 "Error: package build failed. (${2:-no more info})"
cd445739 628 exit 5 ;;
78eab2a1
AM
629 "err_no_package_data" )
630 remove_build_requires
45e2a818 631 echo >&2 "Error: couldn't get out package name/version/release from spec file."
78eab2a1 632 exit 6 ;;
ce40491a 633 "err_tag_exists" )
50321881 634 remove_build_requires
45e2a818 635 echo >&2 "Tag ${2} already exists (spec release: ${3})."
50321881 636 exit 9 ;;
ce40491a 637 "err_fract_rel" )
50321881 638 remove_build_requires
45e2a818 639 echo >&2 "Release ${2} not integer and not a snapshot."
50321881 640 exit 10 ;;
fb96e0b5
AM
641 "err_branch_exists" )
642 remove_build_requires
45e2a818 643 echo >&2 "Tree branch already exists (${2})."
fb96e0b5 644 exit 11 ;;
cfc497c0
ER
645 "err_acl_deny" )
646 remove_build_requires
45e2a818 647 echo >&2 "Error: conditions reject building this spec (${2})."
cfc497c0 648 exit 12 ;;
cd445739 649 esac
45e2a818 650 echo >&2 "Unknown error."
73848362 651 exit 100
cd445739
AM
652}
653
f6711e2a 654init_builder() {
cd445739 655 if [ -n "$DEBUG" ]; then
518ff1fb
ER
656 set -x
657 set -v
0dd6320d 658 fi
cd445739 659
4aeb9973 660 if [ "$NOINIT" != "yes" ] ; then
9c909460
AM
661 TOP_DIR=$(eval $RPM $RPMOPTS --eval '%{_topdir}')
662 REPO_DIR=$TOP_DIR/packages
663 PACKAGE_DIR=$TOP_DIR/packages/$ASSUMED_NAME
29e90b02 664 else
9c909460
AM
665 REPO_DIR="."
666 PACKAGE_DIR="."
29e90b02 667 fi
cd445739 668
a8c9a155 669 __PWD=$(pwd)
00fcec7e 670}
671
f6711e2a 672get_spec() {
c890b916 673
2e5be021 674 update_shell_title "get_spec"
c890b916 675
cd445739 676 if [ -n "$DEBUG" ]; then
518ff1fb
ER
677 set -x
678 set -v
cd445739
AM
679 fi
680
9c909460
AM
681 cd "$REPO_DIR"
682 if [ ! -f "$ASSUMED_NAME/$SPECFILE" ]; then
a8c9a155 683 SPECFILE="$(basename $SPECFILE .spec).spec"
cd445739
AM
684 fi
685 if [ "$NOCVSSPEC" != "yes" ]; then
cd445739 686
049ab214
ER
687 if [ ! -s CVS/Root -a "$NOCVSSPEC" != "yes" ]; then
688 echo "Warning: No CVS access defined - using local .spec file"
689 NOCVSSPEC="yes"
cd445739
AM
690 fi
691
9c909460
AM
692 if [ -d "$ASSUMED_NAME" ]; then
693 cvsup "$ASSUMED_NAME/$SPECFILE" || Exit_error err_no_spec_in_repo
694 else
695 cvsup -c -d $ASSUMED_NAME "packages/$ASSUMED_NAME/$SPECFILE" || Exit_error err_no_spec_in_repo
f123bcb5
ER
696
697 # remove Entries.Static -- so 'cvs up' would update all files in a repo
698 rm "$ASSUMED_NAME/CVS/Entries.Static"
80cef3c1 699 cvsignore_df .cvsignore
f123bcb5
ER
700
701 # create symlinks for tools
daeab113
JR
702 if [ "$SYMLINK_TOOLS" != "no" ]; then
703 for a in dropin md5 adapter builder {relup,compile,repackage}.sh; do
704 [ -f $a ] || continue
705 ln -s ../$a $ASSUMED_NAME
706 cvsignore_df $a
707 done
708 fi
9c909460 709 fi
cd445739 710 fi
049ab214 711
9c909460 712 if [ ! -f "$ASSUMED_NAME/$SPECFILE" ]; then
518ff1fb 713 Exit_error err_no_spec_in_repo
cd445739
AM
714 fi
715
716 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
9c909460 717 chmod $CHMOD_MODE $ASSUMED_NAME/$SPECFILE
cd445739
AM
718 fi
719 unset OPTIONS
9c909460 720 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $ASSUMED_NAME/$SPECFILE
7e40520f 721
ce40491a 722 set_spec_target
cd445739
AM
723}
724
f6711e2a 725find_mirror() {
9c909460 726 cd "$REPO_DIR"
782518da 727 local url="$1"
cd445739 728 if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
939f2c12 729 $CVS_COMMAND update mirrors >&2
cd445739
AM
730 fi
731
732 IFS="|"
782518da
ER
733 local origin mirror name rest ol prefix
734 while read origin mirror name rest; do
735 # skip comments and empty lines
736 if [ -z "$origin" ] || [[ $origin == \#* ]]; then
737 continue
738 fi
a8c9a155
ER
739 ol=$(echo -n "$origin" | wc -c)
740 prefix=$(echo -n "$url" | head -c $ol)
cd445739 741 if [ "$prefix" = "$origin" ] ; then
a8c9a155 742 suffix=$(echo "$url" | cut -b $((ol+1))-)
cd445739
AM
743 echo -n "$mirror$suffix"
744 return 0
745 fi
746 done < mirrors
747 echo "$url"
748}
749
e7e0d4ec 750# Warning: unpredictable results if same URL used twice
f6711e2a 751src_no() {
9c909460 752 cd $PACKAGE_DIR
cd445739
AM
753 rpm_dump | \
754 grep "SOURCEURL[0-9]*[ ]*$1""[ ]*$" | \
755 sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
756 head -n 1 | xargs
1471f6d6 757}
758
f6711e2a 759src_md5() {
e7e0d4ec 760 [ "$NO5" = "yes" ] && return
cd445739
AM
761 no=$(src_no "$1")
762 [ -z "$no" ] && return
9c909460 763 cd $PACKAGE_DIR
e7e0d4ec
ER
764 local md5
765
766 if [ -f additional-md5sums ]; then
767 local spec_rev=$(grep $SPECFILE CVS/Entries 2>/dev/null | sed -e s:/$SPECFILE/:: -e s:/.*::)
768 if [ -z "$spec_rev" ]; then
a8c9a155 769 spec_rev=$(head -n 1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')
e7e0d4ec
ER
770 fi
771 local spec="$SPECFILE[0-9.,]*,$(echo $spec_rev | sed 's/\./\\./g')"
772 md5=$(grep -s -v '^#' additional-md5sums | \
773 grep -E "[ ]$(basename "$1")[ ]+${spec}([ ,]|\$)" | \
774 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
775 grep -E '^[0-9a-f]{32}$')
776
777 if [ "$md5" ]; then
778 if [ $(echo "$md5" | wc -l) != 1 ] ; then
779 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
780 fi
781 echo "$md5" | tail -n 1
782 return
783 fi
cd445739 784 fi
e7e0d4ec
ER
785
786 source_md5=`grep -i "#[ ]*Source$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
787 if [ -n "$source_md5" ]; then
788 echo $source_md5
cd445739 789 else
7805dcb4
PZ
790 source_md5=`grep -i "BuildRequires:[ ]*digest(%SOURCE$no)[ ]*=" $SPECFILE | sed -e 's/.*=//'`
791 if [ -n "$source_md5" ]; then
792 echo $source_md5
793 else
794 # we have empty SourceX-md5, but it is still possible
795 # that we have NoSourceX-md5 AND NoSource: X
796 nosource_md5=`grep -i "#[ ]*NoSource$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
797 if [ -n "$nosource_md5" -a -n "`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" ] ; then
798 echo $nosource_md5
799 fi
cd445739 800 fi
cd445739
AM
801 fi
802}
803
f6711e2a 804distfiles_path() {
06541433
JR
805 echo "by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
806}
807
f6711e2a 808distfiles_url() {
06541433 809 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/$(distfiles_path "$1")"
cd445739
AM
810}
811
f6711e2a 812distfiles_attic_url() {
06541433 813 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/$(distfiles_path "$1")"
cd445739
AM
814}
815
f6711e2a 816good_md5() {
cd445739
AM
817 md5=$(src_md5 "$1")
818 [ "$md5" = "" ] || \
819 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
8ba5cdda
PG
820}
821
f6711e2a 822good_size() {
a8c9a155 823 size=$(find $(nourl "$1") -printf "%s" 2>/dev/null)
ce40491a 824 [ -n "$size" -a "$size" -gt 0 ]
a4b50627
AF
825}
826
f6711e2a 827cvsignore_df() {
947025e5 828 if [ "$CVSIGNORE_DF" != "yes" ]; then
829 return
830 fi
9c909460 831 cvsignore=${PACKAGE_DIR}/.cvsignore
947025e5 832 if ! grep -q "^$1\$" $cvsignore 2> /dev/null; then
833 echo "$1" >> $cvsignore
834 fi
835}
836
f6711e2a 837cvsup() {
ce40491a
ER
838 update_shell_title "cvsup"
839 local OPTIONS="up "
9c909460
AM
840
841 if [ "$1" = "-c" ]; then
842 OPTIONS="co "
843 shift
844 fi
ce40491a
ER
845 if [ -n "$CVSROOT" ]; then
846 OPTIONS="-d $CVSROOT $OPTIONS"
847 fi
b1c6aace 848
ce40491a
ER
849 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
850 OPTIONS="$OPTIONS -A"
851 else
852 if [ -n "$CVSDATE" ]; then
853 OPTIONS="$OPTIONS -D $CVSDATE"
854 fi
855 if [ -n "$CVSTAG" ]; then
856 OPTIONS="$OPTIONS -r $CVSTAG"
857 fi
858 fi
e7fa3b9f 859
ce40491a
ER
860 local result=1
861 local retries_counter=0
862 if [ $# = 1 ]; then
863 update_shell_title "cvsup: $*"
864 else
865 update_shell_title "cvsup: $# files"
866 fi
867 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; do
868 retries_counter=$(( $retries_counter + 1 ))
939f2c12 869 output=$(LC_ALL=C $CVS_COMMAND $OPTIONS "$@" 2>&1)
ce40491a
ER
870 result=$?
871 [ -n "$output" ] && echo "$output"
872 if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
873 echo "Trying again [$*]... ($retries_counter)"
874 update_shell_title "cvsup: retry #$retries_counter"
875 sleep 2
876 continue
877 else
878 break
879 fi
880 done
881 update_shell_title "cvsup: done!"
882 return $result
e7fa3b9f
ER
883}
884
71f8e908 885# returns true if "$1" is ftp, http or https protocol url
f6711e2a 886is_url() {
71f8e908
ER
887 case "$1" in
888 ftp://*|http://*|https://*)
889 return 0
890 ;;
891 esac
892 return 1
893}
894
f6711e2a 895update_md5() {
ecba6ad5
ER
896 if [ $# -eq 0 ]; then
897 return
898 fi
899
900 update_shell_title "update md5"
901 if [ -n "$DEBUG" ]; then
518ff1fb
ER
902 set -x
903 set -v
ecba6ad5
ER
904 fi
905
9c909460 906 cd "$PACKAGE_DIR"
ecba6ad5
ER
907
908 # pass 1: check files to be fetched
909 local todo
910 local need_files
911 for i in "$@"; do
912 local fp=$(nourl "$i")
913 local srcno=$(src_no "$i")
6392b5fd
ER
914 if [ -n "$ADD5" ]; then
915 [ "$fp" = "$i" ] && continue # FIXME what is this check doing?
9c909460
AM
916 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE && continue
917 grep -qiE '^BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE && continue
6392b5fd 918 else
9c909460 919 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE || grep -qiE '^BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE || continue
ecba6ad5
ER
920 fi
921 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
922 need_files="$need_files $i"
923 fi
924 done
925
926 # pass 1a: get needed files
927 if [ "$need_files" ]; then
928 get_files $need_files
929 fi
930
931 # pass 2: proceed with md5 adding or updating
932 for i in "$@"; do
933 local fp=$(nourl "$i")
934 local srcno=$(src_no "$i")
9c909460 935 local md5=$(grep -iE '^#[ ]*(No)?Source'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE )
e19ad799 936 if [ -z "$md5" ]; then
9c909460 937 md5=$(grep -iE '^[ ]*BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE )
6c1b2e7d 938 fi
71f8e908 939 if [ -n "$ADD5" ] && is_url $i || [ -n "$md5" ]; then
6c1b2e7d 940 local tag="# Source$srcno-md5:\t"
71f8e908 941 if [[ "$md5" == *NoSource* ]]; then
6c1b2e7d
PZ
942 tag="# NoSource$srcno-md5:\t"
943 elif [ -n "$USEDIGEST" ]; then
944 tag="BuildRequires:\tdigest(%SOURCE$srcno) = "
71f8e908 945 fi
ecba6ad5 946 md5=$(md5sum "$fp" | cut -f1 -d' ')
15bf3e99 947 echo "Updating Source$srcno ($md5: $fp)."
ecba6ad5 948 perl -i -ne '
6c1b2e7d
PZ
949 print unless (/^\s*#\s*(No)?Source'$srcno'-md5\s*:/i or /^\s*BuildRequires:\s*digest\(%SOURCE'$srcno'\)/i);
950 print "'"$tag$md5"'\n" if /^Source'$srcno'\s*:\s+/;
ecba6ad5 951 ' \
9c909460 952 $PACKAGE_DIR/$SPECFILE
ecba6ad5
ER
953 fi
954 done
955}
956
f6711e2a 957check_md5() {
3fbff8b8
ER
958 [ "$NO5" = "yes" ] && return
959
ecba6ad5
ER
960 update_shell_title "check md5"
961
962 for i in "$@"; do
963 if good_md5 "$i" && good_size "$i"; then
964 continue
965 fi
966
967 echo "MD5 sum mismatch or 0 size. Use -U to refetch sources,"
968 echo "or -5 to update md5 sums, if you're sure files are correct."
969 Exit_error err_no_source_in_repo $i
970 done
971}
972
f6711e2a 973get_files() {
7cb24972 974 update_shell_title "get_files"
cd445739
AM
975
976 if [ -n "$DEBUG" ]; then
518ff1fb
ER
977 set -x
978 set -v
cd445739
AM
979 fi
980
f09c0772 981 if [ $# -gt 0 ]; then
9c909460 982 cd "$PACKAGE_DIR"
cd445739 983
b1c6aace 984 if [ ! -s CVS/Root -a "$NOCVS" != "yes" ]; then
049ab214 985 echo "Warning: No CVS access defined for SOURCES"
b1c6aace
ER
986 NOCVS="yes"
987 fi
988
f2e42a41 989 local nc=0
e7fa3b9f 990 local get_files_cvs=""
3815b69a 991 for i in "$@"; do
f2e42a41 992 nc=$((nc + 1))
dcebdffb 993 local cvsup=0
3815b69a 994 SHELL_TITLE_PREFIX="get_files[$nc/$#]"
f2e42a41 995 update_shell_title "$i"
f09c0772 996 local fp=`nourl "$i"`
ecba6ad5 997 if [ "$SKIP_EXISTING_FILES" = "yes" ] && [ -f "$fp" ]; then
ce40491a 998 continue
18e5347d 999 fi
ecba6ad5 1000
cd445739 1001 FROM_DISTFILES=0
e7e0d4ec 1002 local srcmd5=$(src_md5 "$i")
ecba6ad5
ER
1003
1004 # we know if source/patch is present in cvs/distfiles
1005 # - has md5 (in distfiles)
1006 # - in cvs... ideas?
1007
1008 # CHECK: local file didn't exist or always cvs up (first) requested.
f09c0772 1009 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
cd445739
AM
1010 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
1011 echo "Warning: no URL given for $i"
1012 fi
1013
e7e0d4ec 1014 if [ -z "$NODIST" ] && [ -n "$srcmd5" ]; then
a4b50627 1015 if good_md5 "$i" && good_size "$i"; then
e7e0d4ec 1016 echo "$fp having proper md5sum already exists"
cd445739
AM
1017 continue
1018 fi
4ea1c265 1019 target="$fp"
28b34560 1020
bc10f694 1021 # optionally prefer mirror over distfiles if there's mirror
28b34560 1022 # TODO: build url list and then try each url from the list
bc10f694 1023 if [ -n "$PREFMIRRORS" ] && [ -z "$NOMIRRORS" ] && im=$(find_mirror "$i") && [ "$im" != "$i" ]; then
28b34560
ER
1024 url="$im"
1025 else
1026 url=$(distfiles_url "$i")
1027 fi
1028
cd445739
AM
1029 url_attic=$(distfiles_attic_url "$i")
1030 FROM_DISTFILES=1
ecba6ad5
ER
1031 # is $url local file?
1032 if [[ "$url" = [./]* ]]; then
18a52930 1033 update_shell_title "${GETLOCAL%% *}: $url"
cd445739
AM
1034 ${GETLOCAL} $url $target
1035 else
1036 if [ -z "$NOMIRRORS" ]; then
9e9f8920 1037 url=$(find_mirror "$url")
cd445739 1038 fi
9e9f8920
ER
1039
1040 local uri=${url}
1041 # make shorter message for distfiles urls
1042 if [[ "$uri" = ${PROTOCOL}${DISTFILES_SERVER}* ]] || [[ "$uri" = ${PROTOCOL}${ATTICDISTFILES_SERVER}* ]]; then
1043 uri=${uri#${PROTOCOL}${DISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
1044 uri=${uri#${PROTOCOL}${ATTICDISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
1045 uri="df: $uri"
1046 fi
1047 update_shell_title "${GETURI%% *}: $uri"
ca2e6c31 1048 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 1049 if [ "`echo $url | grep -E 'ftp://'`" ]; then
18a52930 1050 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 1051 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
1052 fi
1053 fi
ecba6ad5
ER
1054
1055 # is it empty file?
1056 if [ ! -s "$target" ]; then
cd445739
AM
1057 rm -f "$target"
1058 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
18a52930 1059 update_shell_title "${GETLOCAL%% *}: $url_attic"
cd445739
AM
1060 ${GETLOCAL} $url_attic $target
1061 else
1062 if [ -z "$NOMIRRORS" ]; then
a8c9a155 1063 url_attic=$(find_mirror "$url_attic")
cd445739 1064 fi
18a52930 1065 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 1066 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 1067 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 1068 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 1069 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
1070 fi
1071 fi
1072 fi
ecba6ad5
ER
1073
1074 if [ -s "$target" ]; then
947025e5 1075 cvsignore_df $target
1076 else
cd445739
AM
1077 rm -f "$target"
1078 FROM_DISTFILES=0
1079 fi
e7e0d4ec 1080 elif [ "$NOCVS" != "yes" -a -z "$srcmd5" ]; then
d05e8080
ER
1081 if [ $# -gt 1 ]; then
1082 get_files_cvs="$get_files_cvs $fp"
1083 update_shell_title "$fp (will cvs up later)"
1084 cvsup=1
1085 else
1086 cvsup $fp
1087 fi
cd445739
AM
1088 fi
1089
f09c0772 1090 if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
cd445739 1091 if [ -z "$NOMIRRORS" ]; then
a8c9a155 1092 im=$(find_mirror "$i")
cd445739
AM
1093 else
1094 im="$i"
1095 fi
ce40491a 1096 update_shell_title "${GETURI%% *}: $im"
cd445739 1097 ${GETURI} "$im" || \
33da77c4 1098 if [ "`echo $im | grep -E 'ftp://'`" ]; then
ce40491a 1099 update_shell_title "${GETURI2%% *}: $im"
cd445739 1100 ${GETURI2} "$im"
7e365483 1101 fi
cd445739
AM
1102 fi
1103
dcebdffb
ER
1104 if [ "$cvsup" = 1 ]; then
1105 continue
1106 fi
1107
cd445739 1108 fi
ecba6ad5
ER
1109
1110 # the md5 check must be moved elsewhere as if we've called from update_md5 the md5 is wrong.
f09c0772 1111 if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
cdbd30e8 1112 if [ -n "GREEDSRC" ]; then
1113 get_greed_sources $i
1114 else
1115 Exit_error err_no_source_in_repo $i
1116 fi
cd445739 1117 fi
2a5f078d 1118
ecba6ad5 1119 # we check md5 here just only to refetch immediately
a4b50627 1120 if good_md5 "$i" && good_size "$i"; then
cd445739
AM
1121 :
1122 elif [ "$FROM_DISTFILES" = 1 ]; then
deccc50e 1123 # wrong md5 from distfiles: remove the file and try again
cd445739 1124 # but only once ...
deccc50e 1125 echo "MD5 sum mismatch. Trying full fetch."
cd445739
AM
1126 FROM_DISTFILES=2
1127 rm -f $target
18a52930 1128 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 1129 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 1130 if [ "`echo $url | grep -E 'ftp://'`" ]; then
ce40491a 1131 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 1132 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739 1133 fi
ecba6ad5 1134 if [ ! -s "$target" ]; then
cd445739 1135 rm -f "$target"
18a52930 1136 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 1137 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 1138 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 1139 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 1140 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
1141 fi
1142 fi
1143 test -s "$target" || rm -f "$target"
1144 fi
cd445739 1145 done
e7fa3b9f
ER
1146 SHELL_TITLE_PREFIX=""
1147
1148 if [ "$get_files_cvs" ]; then
ce40491a 1149 cvsup $get_files_cvs
e7fa3b9f 1150 fi
cd445739
AM
1151
1152 if [ "$CHMOD" = "yes" ]; then
a8c9a155 1153 CHMOD_FILES=$(nourl "$@")
cd445739
AM
1154 if [ -n "$CHMOD_FILES" ]; then
1155 chmod $CHMOD_MODE $CHMOD_FILES
1156 fi
1157 fi
cd445739
AM
1158 fi
1159}
1160
1161make_tagver() {
ce40491a 1162 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1163 set -x
1164 set -v
ce40491a 1165 fi
78eab2a1 1166
ce40491a
ER
1167 # Check whether first character of PACKAGE_NAME is legal for tag name
1168 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
1169 TAG_PREFIX=tag_
1170 fi
d712cc12
ER
1171
1172 # NOTE: CVS tags may must not contain the characters `$,.:;@'
392187d9 1173 TAGVER=$(echo $TAG_PREFIX$PACKAGE_NAME-$PACKAGE_VERSION-$PACKAGE_RELEASE | tr '[.@]' '[_#]')
d712cc12 1174
ce40491a
ER
1175 # Remove #kernel.version_release from TAGVER because tagging sources
1176 # could occur with different kernel-headers than kernel-headers used at build time.
d712cc12
ER
1177 # besides, %{_kernel_ver_str} is not expanded.
1178
1179 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1#%{_kernel_ver_str}
1180 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1
1181
1182 TAGVER=${TAGVER%#*}
ce40491a 1183 echo -n "$TAGVER"
cd445739
AM
1184}
1185
c713aac3
AG
1186# bool is_tag_a_branch(tag)
1187#
1188# returns 1 if a tag is a branch set on SPECFILE
1189is_tag_a_branch() {
1190 if [ -n "$DEBUG" ]; then
1191 set -x
1192 set -v
1193 fi
1194
1195 if [ $# -ne 1 ]; then
1196 return 0;
1197 fi
1198
1199 TAG=$1
f5141bbc 1200
9c909460 1201 cd "$PACKAGE_DIR"
939f2c12 1202 $CVS_COMMAND status -v $SPECFILE | grep -Eiq "${TAG}.+(branch: [0-9.]+)"
c713aac3
AG
1203 return $?
1204}
1205
f6711e2a 1206tag_files() {
cd445739
AM
1207 TAG_FILES="$@"
1208
1209 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1210 set -x
1211 set -v
cd445739
AM
1212 fi
1213
73ef63d8
ER
1214 echo "Version: $PACKAGE_VERSION"
1215 echo "Release: $PACKAGE_RELEASE"
cd445739 1216
a18a9761 1217 local TAGVER
73ef63d8 1218 if [ "$TAG_VERSION" = "yes" ]; then
a18a9761 1219 TAGVER=`make_tagver`
73ef63d8
ER
1220 echo "CVS tag: $TAGVER"
1221 fi
1222 if [ -n "$TAG" ]; then
1223 echo "CVS tag: $TAG"
1224 fi
cd445739 1225
39dcc7de 1226 local OPTIONS="tag $CVS_FORCE"
73ef63d8
ER
1227 if [ -n "$CVSROOT" ]; then
1228 OPTIONS="-d $CVSROOT $OPTIONS"
1229 fi
cd445739 1230
c713aac3
AG
1231 # if a tagname we are about to set already exists
1232 # and happens to be a branch (common case with AC-branch)
1233 # pass -B (allows -F to disturb branch tag)
1234 local _tag=$TAG
1235 if [ "$TAG_VERSION" = "yes" ]; then
1236 _tag=$TAGVER
1237 fi;
1238 is_tag_a_branch $_tag
28c23a72 1239 if [ $? -eq 0 -a $CVS_NSERVER -eq 0 ]; then
c713aac3
AG
1240 OPTIONS="$OPTIONS -B"
1241 fi;
1242
9c909460 1243 cd "$PACKAGE_DIR"
73ef63d8
ER
1244 local tag_files
1245 for i in $TAG_FILES; do
1246 # don't tag files stored on distfiles
1247 [ -n "`src_md5 $i`" ] && continue
1248 local fp=`nourl "$i"`
1249 if [ -f "$fp" ]; then
1250 tag_files="$tag_files $fp"
cdbd30e8 1251 elif [ -n "GREEDSRC" ]; then
1252 get_greed_sources $i
73ef63d8
ER
1253 else
1254 Exit_error err_no_source_in_repo $i
03db3356 1255 fi
73ef63d8 1256 done
03db3356 1257
73ef63d8 1258 if [ "$tag_files" ]; then
cd445739 1259 if [ "$TAG_VERSION" = "yes" ]; then
73ef63d8 1260 update_shell_title "tag sources: $TAGVER"
19ca62ef 1261 printf "Tagging %d files\n" $(echo $tag_files | wc -w)
939f2c12 1262 $CVS_COMMAND $OPTIONS $TAGVER $tag_files || exit
cd445739
AM
1263 fi
1264 if [ -n "$TAG" ]; then
73ef63d8 1265 update_shell_title "tag sources: $TAG"
c4ff623e
ER
1266
1267 while [ "$tag_files" ]; do
1268 local chunk=$(echo $tag_files | tr ' ' '\n' | head -n 100)
1269 printf "Tagging %d files\n" $(echo $chunk | wc -w)
939f2c12 1270 $CVS_COMMAND $OPTIONS $TAG $chunk || exit
c4ff623e
ER
1271 tag_files=$(echo $tag_files | tr ' ' '\n' | tail +101)
1272 done
cd445739 1273 fi
73ef63d8
ER
1274 fi
1275
9c909460 1276 cd "$PACKAGE_DIR"
73ef63d8
ER
1277 if [ "$TAG_VERSION" = "yes" ]; then
1278 update_shell_title "tag spec: $TAGVER"
939f2c12 1279 $CVS_COMMAND $OPTIONS $TAGVER $SPECFILE || exit
73ef63d8
ER
1280 fi
1281 if [ -n "$TAG" ]; then
1282 update_shell_title "tag spec: $TAG"
939f2c12 1283 $CVS_COMMAND $OPTIONS $TAG $SPECFILE || exit
73ef63d8 1284 fi
cd445739
AM
1285}
1286
f6711e2a 1287branch_files() {
cd445739
AM
1288 TAG=$1
1289 echo "CVS branch tag: $TAG"
518ff1fb 1290 shift
cd445739
AM
1291
1292 TAG_FILES="$@"
1293
1294 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1295 set -x
1296 set -v
cd445739
AM
1297 fi
1298
78a5a506 1299 local OPTIONS="tag $CVS_FORCE -b"
ec6b5dfc
AG
1300
1301 # branch exists?
1302 is_tag_a_branch $TAG
1303 if [ $? -eq 1 ]; then
1304 OPTIONS="$OPTIONS -B"
1305 fi
1306
78a5a506
ER
1307 if [ -n "$CVSROOT" ]; then
1308 OPTIONS="-d $CVSROOT $OPTIONS"
1309 fi
9c909460 1310 cd "$PACKAGE_DIR"
78a5a506
ER
1311 local tag_files
1312 for i in $TAG_FILES; do
1313 local fp=`nourl "$i"`
1314 if [ -f "$fp" ]; then
1315 tag_files="$tag_files $fp"
cdbd30e8 1316 elif [ -n "GREEDSRC" ]; then
1317 get_greed_sources $i
78a5a506
ER
1318 else
1319 Exit_error err_no_source_in_repo $i
c10fa4fa 1320 fi
78a5a506
ER
1321 done
1322 if [ "$tag_files" ]; then
939f2c12 1323 $CVS_COMMAND $OPTIONS $TAG $tag_files || exit
78a5a506 1324 fi
c10fa4fa 1325
9c909460 1326 cd "$PACKAGE_DIR"
939f2c12 1327 $CVS_COMMAND $OPTIONS $TAG $SPECFILE || exit
cd445739
AM
1328}
1329
1330
3009b80d
ER
1331# this function should exit early if package can't be built for this arch
1332# this avoids unneccessary BR filling.
1333check_buildarch() {
1334 local out ret
13c3c336 1335 out=$(minirpm --short-circuit -bp --define "'prep exit 0'" --nodeps $SPECFILE 2>&1)
3009b80d
ER
1336 ret=$?
1337 if [ $ret -ne 0 ]; then
1338 echo >&2 "$out"
1339 exit $ret
1340 fi
1341}
1342
f6711e2a 1343build_package() {
2e5be021 1344 update_shell_title "build_package"
cd445739 1345 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1346 set -x
1347 set -v
cd445739 1348 fi
5a491465 1349
9c909460 1350 cd "$PACKAGE_DIR"
cd445739
AM
1351
1352 if [ -n "$TRY_UPGRADE" ]; then
ce40491a 1353 update_shell_title "build_package: try_upgrade"
cd445739 1354 if [ -n "$FLOAT_VERSION" ]; then
45e2a818 1355 TNOTIFY=$(./pldnotify.awk $SPECFILE -n) || exit 1
cd445739 1356 else
45e2a818 1357 TNOTIFY=$(./pldnotify.awk $SPECFILE) || exit 1
cd445739
AM
1358 fi
1359
45e2a818 1360 TNEWVER=$(echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }')
cd445739
AM
1361
1362 if [ -n "$TNEWVER" ]; then
1363 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
1364 echo "New version found, updating spec file to version " $TNEWVER
257af81b
ER
1365 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1366 cp -f $SPECFILE $SPECFILE.bak
1367 fi
cd445739
AM
1368 chmod +w $SPECFILE
1369 eval "perl -pi -e 's/Version:\t"$TOLDVER"/Version:\t"$TNEWVER"/gs' $SPECFILE"
f7b91886 1370 eval "perl -pi -e 's/Release:\t[1-9]{0,4}/Release:\t0.1/' $SPECFILE"
518ff1fb
ER
1371 parse_spec
1372 NODIST="yes" get_files $SOURCES $PATCHES
6392b5fd 1373 update_md5 $SOURCES
975d7b23 1374
cd445739
AM
1375 unset TOLDVER TNEWVER TNOTIFY
1376 fi
1377 fi
9c909460 1378 cd "$PACKAGE_DIR"
2a5f078d 1379
cd445739
AM
1380 case "$COMMAND" in
1381 build )
1382 BUILD_SWITCH="-ba" ;;
1383 build-binary )
1384 BUILD_SWITCH="-bb" ;;
1385 build-source )
1386 BUILD_SWITCH="-bs --nodeps" ;;
1387 build-prep )
1388 BUILD_SWITCH="-bp --nodeps" ;;
6594293d
AG
1389 build-build )
1390 BUILD_SWITCH="-bc" ;;
1391 build-install )
1392 BUILD_SWITCH="-bi" ;;
1393 build-list )
1394 BUILD_SWITCH="-bl" ;;
1395
cd445739 1396 esac
c890b916 1397
2e5be021 1398 update_shell_title "build_package: $COMMAND"
cd445739
AM
1399 if [ -n "$LOGFILE" ]; then
1400 LOG=`eval echo $LOGFILE`
1401 if [ -d "$LOG" ]; then
1402 echo "Log file $LOG is a directory."
1403 echo "Parse error in the spec?"
518ff1fb 1404 Exit_error err_build_fail
cd445739
AM
1405 fi
1406 if [ -n "$LASTLOG_FILE" ]; then
1407 echo "LASTLOG=$LOG" > $LASTLOG_FILE
1408 fi
525bf240
ER
1409 RES_FILE=$(mktemp -t builder.XXXXXX || ${TMPDIR:-/tmp}/builder.$RANDOM)
1410
9c909460 1411 (time eval ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND --define \'_specdir $PACKAGE_DIR\' --define \'_sourcedir $PACKAGE_DIR\' $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
cd445739
AM
1412 RETVAL=`cat $RES_FILE`
1413 rm $RES_FILE
1414 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
1415 if [ "$RETVAL" -eq "0" ]; then
1416 mv $LOG $LOGDIROK
1417 else
1418 mv $LOG $LOGDIRFAIL
1419 fi
1420 fi
8ba5cdda 1421 else
9c909460 1422 eval ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND --define \'_specdir $PACKAGE_DIR\' --define \'_sourcedir $PACKAGE_DIR\' $SPECFILE
cd445739 1423 RETVAL=$?
8ba5cdda 1424 fi
cd445739
AM
1425 if [ "$RETVAL" -ne "0" ]; then
1426 if [ -n "$TRY_UPGRADE" ]; then
796a8a95 1427 echo "\n!!! Package with new version cannot be built automagically\n"
257af81b
ER
1428 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1429 mv -f $SPECFILE.bak $SPECFILE
1430 fi
cd445739 1431 fi
518ff1fb 1432 Exit_error err_build_fail
cd445739
AM
1433 fi
1434 unset BUILD_SWITCH
1435}
1436
f6711e2a 1437nourl() {
cd445739
AM
1438 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1439}
1440
f6711e2a 1441install_required_packages() {
cd445739
AM
1442 run_poldek -vi $1
1443 return $?
1444}
1445
f6711e2a 1446find_spec_bcond() { # originally from /usr/lib/rpm/find-spec-bcond
fa4bf1df 1447 local SPEC="$1"
fa4bf1df
ER
1448 awk -F"\n" '
1449 /^%changelog/ { exit }
fa4bf1df
ER
1450 /^%bcond_with/{
1451 match($0, /bcond_with(out)?[ \t]+[_a-zA-Z0-9]+/);
8ff97f39
ER
1452 bcond = substr($0, RSTART + 6, RLENGTH - 6);
1453 gsub(/[ \t]+/, "_", bcond);
fa4bf1df
ER
1454 print bcond
1455 }' $SPEC | LC_ALL=C sort -u
1456}
1457
117d9861 1458process_bcondrc() {
301cbfd4
ER
1459 # expand bconds from ~/.bcondrc
1460 # The file structure is like gentoo's package.use:
1461 # ---
1462 # * -selinux
1463 # samba -mysql -pgsql
47a8df12 1464 # w32codec-installer license_agreement
301cbfd4
ER
1465 # php +mysqli
1466 # ---
fa4bf1df 1467 if ([ -f $HOME/.bcondrc ] || ([ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ])); then
117d9861
ER
1468 :
1469 else
1470 return
1471 fi
301cbfd4 1472
117d9861 1473 SN=${SPECFILE%%\.spec}
c8a3e2ac 1474
117d9861
ER
1475 local bcondrc=$HOME/.bcondrc
1476 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && bcondrc=$HOME_ETC/.bcondrc
301cbfd4 1477
117d9861 1478 local bcond_avail=$(find_spec_bcond $SPECFILE)
301cbfd4 1479
117d9861
ER
1480 while read pkg flags; do
1481 # ignore comments
1482 [[ "$pkg" == \#* ]] && continue
1483
1484 # any package or current package?
1485 if [ "$pkg" = "*" ] || [ "$pkg" = "$PACKAGE_NAME" ] || [ "$pkg" = "$SN" ]; then
1486 for flag in $flags; do
1487 local opt=${flag#[+-]}
1488
1489 # use only flags which are in this package.
1490 if [[ $bcond_avail = *${opt}* ]]; then
1491 if [[ $flag = -* ]]; then
1492 if [[ $BCOND != *--with?${opt}* ]]; then
1493 BCOND="$BCOND --without $opt"
1494 fi
1495 else
1496 if [[ $BCOND != *--without?${opt}* ]]; then
1497 BCOND="$BCOND --with $opt"
301cbfd4
ER
1498 fi
1499 fi
117d9861
ER
1500 fi
1501 done
1502 fi
1503 done < $bcondrc
1504 update_shell_title "parse ~/.bcondrc: DONE!"
1505}
1506
8ff97f39 1507set_bconds_values() {
117d9861
ER
1508 update_shell_title "set bcond values"
1509
1510 AVAIL_BCONDS_WITHOUT=""
1511 AVAIL_BCONDS_WITH=""
8ff97f39
ER
1512
1513 if egrep -q '^# *_with' ${SPECFILE}; then
1514 echo >&2 "ERROR: This spec has old style bconds."
1515 exit 1
1516 fi
1517
1518 if ! grep -q '^%bcond' ${SPECFILE}; then
117d9861 1519 return
301cbfd4
ER
1520 fi
1521
117d9861
ER
1522 local bcond_avail=$(find_spec_bcond $SPECFILE)
1523 process_bcondrc "$SPECFILE"
1524
fa4bf1df 1525 update_shell_title "parse bconds"
2a5f078d 1526
8ff97f39
ER
1527 local opt bcond
1528 for opt in $bcond_avail; do
1529 case "$opt" in
1530 without_*)
1531 bcond=${opt#without_}
1532 if [[ "$BCOND" = *--without?${bcond}* ]]; then
1533 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$bcond>"
1534 else
1535 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $bcond"
1536 fi
cd445739 1537 ;;
8ff97f39
ER
1538 with_*)
1539 bcond=${opt#with_}
1540 if [[ "$BCOND" = *--with?${bcond}* ]]; then
1541 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$bcond>"
1542 else
1543 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $bcond"
1544 fi
cd445739 1545 ;;
8ff97f39
ER
1546 *)
1547 echo >&2 "ERROR: unexpected '$opt' in set_bconds_values"
1548 exit 1
1549 ;;
1550 esac
1551 done
cd445739
AM
1552}
1553
f6711e2a 1554run_sub_builder() {
cd445739 1555 package_name="${1}"
af6b168f 1556 update_shell_title "run_sub_builder $package_name"
cd445739
AM
1557 #
1558